<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <base data-ice="baseUrl" href="../../">
  <title data-ice="title">src/Formio.js | formiojs</title>
  <link type="text/css" rel="stylesheet" href="css/style.css">
  <link type="text/css" rel="stylesheet" href="css/prettify-tomorrow.css">
  <script src="script/prettify/prettify.js"></script>
  <script src="script/manual.js"></script>
<meta name="description" content="JavaScript powered Forms with JSON Form Builder"><meta property="twitter:card" content="summary"><meta property="twitter:title" content="formiojs"><meta property="twitter:description" content="JavaScript powered Forms with JSON Form Builder"></head>
<body class="layout-container" data-ice="rootContainer">

<header>
  <a href="./">Home</a>
  
  <a href="identifiers.html">Reference</a>
  <a href="source.html">Source</a>
  
  <div class="search-box">
  <span>
    <img src="./image/search.png">
    <span class="search-input-edge"></span><input class="search-input"><span class="search-input-edge"></span>
  </span>
    <ul class="search-result"></ul>
  </div>
<a href="https://gitlab.com/atorico.com/formio/formio.js.git">Repository</a></header>

<nav class="navigation" data-ice="nav"><div>
  <ul>
    
  <li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/EventEmitter.js~EventEmitter.html">EventEmitter</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/Form.js~Form.html">Form</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/FormBuilder.js~FormBuilder.html">FormBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/PDFBuilder.js~PDFBuilder.html">PDFBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/WizardBuilder.js~WizardBuilder.html">WizardBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-embed">embed</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#builders">builders</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/builders/Builders.js~Builders.html">Builders</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components">components</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/Components.js~Components.html">Components</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-component">components/_classes/component</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Component">Component</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-component-editform">components/_classes/component/editForm</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-EditFormUtils">EditFormUtils</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-componentmodal">components/_classes/componentModal</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/componentModal/ComponentModal.js~ComponentModal.html">ComponentModal</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-field">components/_classes/field</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/field/Field.js~Field.html">Field</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-nested">components/_classes/nested</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/nested/NestedComponent.js~NestedComponent.html">NestedComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-NestedComponent">NestedComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-address">components/address</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Address">Address</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-button">components/button</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Button">Button</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-checkbox">components/checkbox</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/checkbox/Checkbox.js~CheckBoxComponent.html">CheckBoxComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Checkbox">Checkbox</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-columns">components/columns</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/columns/Columns.js~ColumnsComponent.html">ColumnsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Columns">Columns</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-container">components/container</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/container/Container.js~ContainerComponent.html">ContainerComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Container">Container</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-content">components/content</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/content/Content.js~ContentComponent.html">ContentComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Content">Content</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-currency">components/currency</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/currency/Currency.js~CurrencyComponent.html">CurrencyComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Currency">Currency</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datagrid">components/datagrid</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DataGrid">DataGrid</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datamap">components/datamap</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/datamap/DataMap.js~DataMapComponent.html">DataMapComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DataMap">DataMap</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datetime">components/datetime</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/datetime/DateTime.js~DateTimeComponent.html">DateTimeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DateTime">DateTime</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-day">components/day</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Day">Day</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-editgrid">components/editgrid</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-EditGrid">EditGrid</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-email">components/email</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/email/Email.js~EmailComponent.html">EmailComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Email">Email</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-fieldset">components/fieldset</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/fieldset/Fieldset.js~FieldsetComponent.html">FieldsetComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Fieldset">Fieldset</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-file">components/file</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-File">File</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-form">components/form</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Form">Form</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-hidden">components/hidden</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/hidden/Hidden.js~HiddenComponent.html">HiddenComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Hidden">Hidden</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-html">components/html</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/html/HTML.js~HTMLComponent.html">HTMLComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-HTML">HTML</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-number">components/number</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/number/Number.js~NumberComponent.html">NumberComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Number">Number</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-panel">components/panel</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Panel">Panel</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-password">components/password</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/password/Password.js~PasswordComponent.html">PasswordComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Password">Password</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-phonenumber">components/phonenumber</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/phonenumber/PhoneNumber.js~PhoneNumberComponent.html">PhoneNumberComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-PhoneNumber">PhoneNumber</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-radio">components/radio</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/radio/Radio.js~RadioComponent.html">RadioComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Radio">Radio</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-recaptcha">components/recaptcha</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/recaptcha/ReCaptcha.js~ReCaptchaComponent.html">ReCaptchaComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-ReCaptcha">ReCaptcha</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-resource">components/resource</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/resource/Resource.js~ResourceComponent.html">ResourceComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Resource">Resource</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-select">components/select</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Select">Select</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-select-fixtures">components/select/fixtures</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-multiSelect">multiSelect</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-multiSelectOptions">multiSelectOptions</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-selectboxes">components/selectboxes</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-SelectBoxes">SelectBoxes</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-signature">components/signature</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/signature/Signature.js~SignatureComponent.html">SignatureComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Signature">Signature</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-survey">components/survey</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Survey">Survey</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-table">components/table</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/table/Table.js~TableComponent.html">TableComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Table">Table</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tabs">components/tabs</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tabs/Tabs.js~TabsComponent.html">TabsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tabs">Tabs</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tags">components/tags</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tags/Tags.js~TagsComponent.html">TagsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tags">Tags</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-textarea">components/textarea</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-TextArea">TextArea</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-textfield">components/textfield</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-TextField">TextField</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-time">components/time</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/time/Time.js~TimeComponent.html">TimeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Time">Time</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tree">components/tree</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tree/Node.js~Node.html">Node</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tree">Tree</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-unknown">components/unknown</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/unknown/Unknown.js~UnknownComponent.html">UnknownComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Unknown">Unknown</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-url">components/url</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/url/Url.js~UrlComponent.html">UrlComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Url">Url</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-well">components/well</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/well/Well.js~WellComponent.html">WellComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Well">Well</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib">contrib</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-Contrib">Contrib</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-edittable">contrib/edittable</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/edittable/EditTable.js~EditTableComponent.html">EditTableComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-EditTable">EditTable</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-location">contrib/location</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/location/Location.js~LocationComponent.html">LocationComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Location">Location</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-modaledit">contrib/modaledit</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/modaledit/ModalEdit.js~ModalEditComponent.html">ModalEditComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-ModalEdit">ModalEdit</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-stripe-checkout">contrib/stripe/checkout</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/stripe/checkout/StripeCheckout.js~StripeCheckoutComponent.html">StripeCheckoutComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-stripe-stripe">contrib/stripe/stripe</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/stripe/stripe/Stripe.js~StripeComponent.html">StripeComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#displays">displays</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/displays/Displays.js~Displays.html">Displays</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers">providers</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/Providers.js~Providers.html">Providers</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-address">providers/address</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/AddressProvider.js~AddressProvider.html">AddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/AzureAddressProvider.js~AzureAddressProvider.html">AzureAddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/CustomAddressProvider.js~CustomAddressProvider.html">CustomAddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/NominatimAddressProvider.js~NominatimAddressProvider.html">NominatimAddressProvider</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-processor">providers/processor</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-fileProcessor">fileProcessor</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-storage">providers/storage</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-azure">azure</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-base64">base64</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-dropbox">dropbox</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-indexeddb">indexeddb</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-s3">s3</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getFormioUploadAdapterPlugin">getFormioUploadAdapterPlugin</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-url">url</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-setXhrHeaders">setXhrHeaders</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-XHR">XHR</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#templates">templates</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/templates/Templates.js~Templates.html">Templates</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#templates-bootstrap">templates/bootstrap</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-iconClass">iconClass</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#utils">utils</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/utils/ChoicesWrapper.js~ChoicesWrapper.html">ChoicesWrapper</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-checkInvalidDate">checkInvalidDate</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-lessOrGreater">lessOrGreater</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-applyFormChanges">applyFormChanges</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-eachComponent">eachComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-escapeRegExCharacters">escapeRegExCharacters</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-findComponent">findComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-findComponents">findComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-flattenComponents">flattenComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-formatAsCurrency">formatAsCurrency</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-generateFormChange">generateFormChange</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getComponent">getComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getStrings">getStrings</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getValue">getValue</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-hasCondition">hasCondition</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-isLayoutComponent">isLayoutComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-matchComponent">matchComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-parseFloatExt">parseFloatExt</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-removeComponent">removeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-searchComponents">searchComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-KEY_CODES">KEY_CODES</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-Evaluator">Evaluator</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-CALENDAR_ERROR_MESSAGES">CALENDAR_ERROR_MESSAGES</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#utils-jsonlogic">utils/jsonlogic</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-lodashOperators">lodashOperators</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#validator">validator</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/validator/Rules.js~Rules.html">Rules</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/validator/Validator.js~ValidationChecker.html">ValidationChecker</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#widgets">widgets</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/widgets/InputWidget.js~InputWidget.html">InputWidget</a></span></span></li>
</ul>
</div>
</nav>

<div class="content" data-ice="content"><h1 data-ice="title">src/Formio.js</h1>
<pre class="source-code line-number raw-source-code"><code class="prettyprint linenums" data-ice="content">/* globals OktaAuth */
// Intentionally use native-promise-only here... Other promise libraries (es6-promise)
// duck-punch the global Promise definition which messes up Angular 2 since it
// also duck-punches the global Promise definition. For now, keep native-promise-only.
import NativePromise from &apos;native-promise-only&apos;;
import fetchPonyfill from &apos;fetch-ponyfill&apos;;
import EventEmitter from &apos;./EventEmitter&apos;;
import cookies from &apos;browser-cookies&apos;;
import Providers from &apos;./providers&apos;;
import _intersection from &apos;lodash/intersection&apos;;
import _get from &apos;lodash/get&apos;;
import _cloneDeep from &apos;lodash/cloneDeep&apos;;
import _defaults from &apos;lodash/defaults&apos;;
import { eachComponent } from &apos;./utils/utils&apos;;
import jwtDecode from &apos;jwt-decode&apos;;
import &apos;./polyfills&apos;;

const { fetch, Headers } = fetchPonyfill({
  Promise: NativePromise
});

const isBoolean = (val) =&gt; typeof val === typeof true;
const isNil = (val) =&gt; val === null || val === undefined;
const isObject = (val) =&gt; val &amp;&amp; typeof val === &apos;object&apos;;

function cloneResponse(response) {
  const copy = _cloneDeep(response);

  if (Array.isArray(response)) {
    copy.skip = response.skip;
    copy.limit = response.limit;
    copy.serverCount = response.serverCount;
  }

  return copy;
}

/**
 * The Formio interface class.
 *
 *   let formio = new Formio(&apos;https://examples.form.io/example&apos;);
 */
class Formio {
  /* eslint-disable max-statements */
  constructor(path, options = {}) {
    // Ensure we have an instance of Formio.
    if (!(this instanceof Formio)) {
      return new Formio(path);
    }

    // Initialize our variables.
    this.base = &apos;&apos;;
    this.projectsUrl = &apos;&apos;;
    this.projectUrl = &apos;&apos;;
    this.projectId = &apos;&apos;;
    this.roleUrl = &apos;&apos;;
    this.rolesUrl = &apos;&apos;;
    this.roleId = &apos;&apos;;
    this.formUrl = &apos;&apos;;
    this.formsUrl = &apos;&apos;;
    this.formId = &apos;&apos;;
    this.submissionsUrl = &apos;&apos;;
    this.submissionUrl = &apos;&apos;;
    this.submissionId = &apos;&apos;;
    this.actionsUrl = &apos;&apos;;
    this.actionId = &apos;&apos;;
    this.actionUrl = &apos;&apos;;
    this.vsUrl = &apos;&apos;;
    this.vId = &apos;&apos;;
    this.vUrl = &apos;&apos;;
    this.query = &apos;&apos;;

    // Store the original path and options.
    this.path = path;
    this.options = options;

    if (options.hasOwnProperty(&apos;base&apos;)) {
      this.base = options.base;
    }
    else if (Formio.baseUrl) {
      this.base = Formio.baseUrl;
    }
    else if (typeof window !== &apos;undefined&apos;) {
      this.base = window.location.href.match(/http[s]?:\/\/api./)[0];
    }

    if (!path) {
      // Allow user to create new projects if this was instantiated without
      // a url
      this.projectUrl = Formio.projectUrl || `${this.base}/project`;
      this.projectsUrl = `${this.base}/project`;
      this.projectId = false;
      this.query = &apos;&apos;;
      return;
    }

    if (options.hasOwnProperty(&apos;project&apos;)) {
      this.projectUrl = options.project;
    }

    const project = this.projectUrl || Formio.projectUrl;
    const projectRegEx = /(^|\/)(project)($|\/[^/]+)/;
    const isProjectUrl = (path.search(projectRegEx) !== -1);

    // The baseURL is the same as the projectUrl, and does not contain &quot;/project/MONGO_ID&quot; in
    // its domain. This is almost certainly against the Open Source server.
    if (project &amp;&amp; this.base === project &amp;&amp; !isProjectUrl) {
      this.noProject = true;
      this.projectUrl = this.base;
    }

    // Normalize to an absolute path.
    if ((path.indexOf(&apos;http&apos;) !== 0) &amp;&amp; (path.indexOf(&apos;//&apos;) !== 0)) {
      path = this.base + path;
    }

    const hostparts = this.getUrlParts(path);
    let parts = [];
    const hostName = hostparts[1] + hostparts[2];
    path = hostparts.length &gt; 3 ? hostparts[3] : &apos;&apos;;
    const queryparts = path.split(&apos;?&apos;);
    if (queryparts.length &gt; 1) {
      path = queryparts[0];
      this.query = `?${queryparts[1]}`;
    }

    // Register a specific path.
    const registerPath = (name, base) =&gt; {
      this[`${name}sUrl`] = `${base}/${name}`;
      const regex = new RegExp(`/${name}/([^/]+)`);
      if (path.search(regex) !== -1) {
        parts = path.match(regex);
        this[`${name}Url`] = parts ? (base + parts[0]) : &apos;&apos;;
        this[`${name}Id`] = (parts.length &gt; 1) ? parts[1] : &apos;&apos;;
        base += parts[0];
      }
      return base;
    };

    // Register an array of items.
    const registerItems = (items, base, staticBase) =&gt; {
      for (const i in items) {
        if (items.hasOwnProperty(i)) {
          const item = items[i];
          if (Array.isArray(item)) {
            registerItems(item, base, true);
          }
          else {
            const newBase = registerPath(item, base);
            base = staticBase ? base : newBase;
          }
        }
      }
    };

    if (!this.projectUrl || (this.projectUrl === this.base)) {
      // If a project uses Subdirectories path type, we need to specify a projectUrl
      if (!this.projectUrl &amp;&amp; !isProjectUrl &amp;&amp; Formio.pathType === &apos;Subdirectories&apos;) {
        const regex = `^${hostName.replace(/\//g, &apos;\\/&apos;)}.[^/]+`;
        const match = project.match(new RegExp(regex));
        this.projectUrl = match ? match[0] : hostName;
      }
      else {
        this.projectUrl = hostName;
      }
    }
    // Check if we have a specified path type.
    let isNotSubdomainType = false;

    if (Formio.pathType) {
      isNotSubdomainType = Formio.pathType !== &apos;Subdomains&apos;;
    }

    if (!this.noProject) {
      // Determine the projectUrl and projectId
      if (isProjectUrl) {
        // Get project id as project/:projectId.
        registerItems([&apos;project&apos;], hostName);
        path = path.replace(projectRegEx, &apos;&apos;);
      }
      else if (hostName === this.base) {
        // Get project id as first part of path (subdirectory).
        if (hostparts.length &gt; 3 &amp;&amp; path.split(&apos;/&apos;).length &gt; 1) {
          const pathParts = path.split(&apos;/&apos;);
          pathParts.shift(); // Throw away the first /.
          this.projectId = pathParts.shift();
          path = `/${pathParts.join(&apos;/&apos;)}`;
          this.projectUrl = `${hostName}/${this.projectId}`;
        }
      }
      else {
        // Get project id from subdomain.
        if (hostparts.length &gt; 2 &amp;&amp; (hostparts[2].split(&apos;.&apos;).length &gt; 2 || hostName.includes(&apos;localhost&apos;)) &amp;&amp; !isNotSubdomainType) {
          this.projectUrl = hostName;
          this.projectId = hostparts[2].split(&apos;.&apos;)[0];
        }
      }
      this.projectsUrl = this.projectsUrl || `${this.base}/project`;
    }

    // Configure Role urls and role ids.
    registerItems([&apos;role&apos;], this.projectUrl);

    // Configure Form urls and form ids.
    if (/(^|\/)(form)($|\/)/.test(path)) {
      registerItems([&apos;form&apos;, [&apos;submission&apos;, &apos;action&apos;, &apos;v&apos;]], this.projectUrl);
    }
    else {
      const subRegEx = new RegExp(&apos;/(submission|action|v)($|/.*)&apos;);
      const subs = path.match(subRegEx);
      this.pathType = (subs &amp;&amp; (subs.length &gt; 1)) ? subs[1] : &apos;&apos;;
      path = path.replace(subRegEx, &apos;&apos;);
      path = path.replace(/\/$/, &apos;&apos;);
      this.formsUrl = `${this.projectUrl}/form`;
      this.formUrl = path ? this.projectUrl + path : &apos;&apos;;
      this.formId = path.replace(/^\/+|\/+$/g, &apos;&apos;);
      const items = [&apos;submission&apos;, &apos;action&apos;, &apos;v&apos;];
      for (const i in items) {
        if (items.hasOwnProperty(i)) {
          const item = items[i];
          this[`${item}sUrl`] = `${this.projectUrl + path}/${item}`;
          if ((this.pathType === item) &amp;&amp; (subs.length &gt; 2) &amp;&amp; subs[2]) {
            this[`${item}Id`] = subs[2].replace(/^\/+|\/+$/g, &apos;&apos;);
            this[`${item}Url`] = this.projectUrl + path + subs[0];
          }
        }
      }
    }

    // Set the app url if it is not set.
    if (!Formio.projectUrlSet) {
      Formio.projectUrl = this.projectUrl;
    }
  }
  /* eslint-enable max-statements */

  delete(type, opts) {
    const _id = `${type}Id`;
    const _url = `${type}Url`;
    if (!this[_id]) {
      return NativePromise.reject(&apos;Nothing to delete&apos;);
    }
    Formio.cache = {};
    return this.makeRequest(type, this[_url], &apos;delete&apos;, null, opts);
  }

  index(type, query, opts) {
    const _url = `${type}Url`;
    query = query || &apos;&apos;;
    if (query &amp;&amp; isObject(query)) {
      query = `?${Formio.serialize(query.params)}`;
    }
    return this.makeRequest(type, this[_url] + query, &apos;get&apos;, null, opts);
  }

  save(type, data, opts) {
    const _id = `${type}Id`;
    const _url = `${type}Url`;
    const method = (this[_id] || data._id) ? &apos;put&apos; : &apos;post&apos;;
    let reqUrl = this[_id] ? this[_url] : this[`${type}sUrl`];
    if (!this[_id] &amp;&amp; data._id &amp;&amp; (method === &apos;put&apos;) &amp;&amp; !reqUrl.includes(data._id)) {
      reqUrl += `/${data._id}`;
    }
    Formio.cache = {};
    return this.makeRequest(type, reqUrl + this.query, method, data, opts);
  }

  load(type, query, opts) {
    const _id = `${type}Id`;
    const _url = `${type}Url`;
    if (query &amp;&amp; isObject(query)) {
      query = Formio.serialize(query.params);
    }
    if (query) {
      query = this.query ? (`${this.query}&amp;${query}`) : (`?${query}`);
    }
    else {
      query = this.query;
    }
    if (!this[_id]) {
      return NativePromise.reject(`Missing ${_id}`);
    }
    return this.makeRequest(type, this[_url] + query, &apos;get&apos;, null, opts);
  }

  makeRequest(...args) {
    return Formio.makeRequest(this, ...args);
  }

  loadProject(query, opts) {
    return this.load(&apos;project&apos;, query, opts);
  }

  saveProject(data, opts) {
    return this.save(&apos;project&apos;, data, opts);
  }

  deleteProject(opts) {
    return this.delete(&apos;project&apos;, opts);
  }

  static loadProjects(query, opts) {
    query = query || &apos;&apos;;
    if (isObject(query)) {
      query = `?${Formio.serialize(query.params)}`;
    }
    return Formio.makeStaticRequest(`${Formio.baseUrl}/project${query}`, &apos;GET&apos;, null, opts);
  }

  loadRole(opts) {
    return this.load(&apos;role&apos;, null, opts);
  }

  saveRole(data, opts) {
    return this.save(&apos;role&apos;, data, opts);
  }

  deleteRole(opts) {
    return this.delete(&apos;role&apos;, opts);
  }

  loadRoles(opts) {
    return this.index(&apos;roles&apos;, null, opts);
  }

  loadForm(query, opts) {
    return this.load(&apos;form&apos;, query, opts)
      .then((currentForm) =&gt; {
        // Check to see if there isn&apos;t a number in vId.
        if (!currentForm.revisions || isNaN(parseInt(this.vId))) {
          return currentForm;
        }
        // If a submission already exists but form is marked to load current version of form.
        if (currentForm.revisions === &apos;current&apos; &amp;&amp; this.submissionId) {
          return currentForm;
        }
        // If they specified a revision form, load the revised form components.
        if (query &amp;&amp; isObject(query)) {
          query = Formio.serialize(query.params);
        }
        if (query) {
          query = this.query ? (`${this.query}&amp;${query}`) : (`?${query}`);
        }
        else {
          query = this.query;
        }
        return this.makeRequest(&apos;form&apos;, this.vUrl + query, &apos;get&apos;, null, opts)
          .then((revisionForm) =&gt; {
            currentForm._vid = revisionForm._vid;
            currentForm.components = revisionForm.components;
            currentForm.settings = revisionForm.settings;
            // Using object.assign so we don&apos;t cross polinate multiple form loads.
            return Object.assign({}, currentForm);
          })
          // If we couldn&apos;t load the revision, just return the original form.
          .catch(() =&gt; Object.assign({}, currentForm));
      });
  }

  saveForm(data, opts) {
    return this.save(&apos;form&apos;, data, opts);
  }

  deleteForm(opts) {
    return this.delete(&apos;form&apos;, opts);
  }

  loadForms(query, opts) {
    return this.index(&apos;forms&apos;, query, opts);
  }

  loadSubmission(query, opts) {
    return this.load(&apos;submission&apos;, query, opts)
      .then((submission) =&gt; {
        this.vId = submission._fvid;
        this.vUrl = `${this.formUrl}/v/${this.vId}`;
        return submission;
      });
  }

  saveSubmission(data, opts) {
    if (!isNaN(parseInt(this.vId))) {
      data._fvid = this.vId;
    }
    return this.save(&apos;submission&apos;, data, opts);
  }

  deleteSubmission(opts) {
    return this.delete(&apos;submission&apos;, opts);
  }

  loadSubmissions(query, opts) {
    return this.index(&apos;submissions&apos;, query, opts);
  }

  loadAction(query, opts) {
    return this.load(&apos;action&apos;, query, opts);
  }

  saveAction(data, opts) {
    return this.save(&apos;action&apos;, data, opts);
  }

  deleteAction(opts) {
    return this.delete(&apos;action&apos;, opts);
  }

  loadActions(query, opts) {
    return this.index(&apos;actions&apos;, query, opts);
  }

  availableActions() {
    return this.makeRequest(&apos;availableActions&apos;, `${this.formUrl}/actions`);
  }

  actionInfo(name) {
    return this.makeRequest(&apos;actionInfo&apos;, `${this.formUrl}/actions/${name}`);
  }

  isObjectId(id) {
    const checkForHexRegExp = new RegExp(&apos;^[0-9a-fA-F]{24}$&apos;);
    return checkForHexRegExp.test(id);
  }

  getProjectId() {
    if (!this.projectId) {
      return NativePromise.resolve(&apos;&apos;);
    }
    if (this.isObjectId(this.projectId)) {
      return NativePromise.resolve(this.projectId);
    }
    else {
      return this.loadProject().then((project) =&gt; {
        return project._id;
      });
    }
  }

  getFormId() {
    if (!this.formId) {
      return NativePromise.resolve(&apos;&apos;);
    }
    if (this.isObjectId(this.formId)) {
      return NativePromise.resolve(this.formId);
    }
    else {
      return this.loadForm().then((form) =&gt; {
        return form._id;
      });
    }
  }

  currentUser(options) {
    return Formio.currentUser(this, options);
  }

  accessInfo() {
    return Formio.accessInfo(this);
  }

  /**
   * Returns the JWT token for this instance.
   *
   * @return {*}
   */
  getToken(options) {
    return Formio.getToken(Object.assign({ formio: this }, this.options, options));
  }

  /**
   * Sets the JWT token for this instance.
   *
   * @return {*}
   */
  setToken(token, options) {
    return Formio.setToken(token, Object.assign({ formio: this }, this.options, options));
  }

  /**
   * Returns a temporary authentication token for single purpose token generation.
   */
  getTempToken(expire, allowed, options) {
    const token = Formio.getToken(options);
    if (!token) {
      return NativePromise.reject(&apos;You must be authenticated to generate a temporary auth token.&apos;);
    }
    const authUrl = Formio.authUrl || this.projectUrl;
    return this.makeRequest(&apos;tempToken&apos;, `${authUrl}/token`, &apos;GET&apos;, null, {
      ignoreCache: true,
      header: new Headers({
        &apos;x-expire&apos;: expire,
        &apos;x-allow&apos;: allowed
      })
    });
  }

  /**
   * Get a download url for a submission PDF of this submission.
   *
   * @return {*}
   */
  getDownloadUrl(form) {
    if (!this.submissionId) {
      return NativePromise.resolve(&apos;&apos;);
    }

    if (!form) {
      // Make sure to load the form first.
      return this.loadForm().then((_form) =&gt; {
        if (!_form) {
          return &apos;&apos;;
        }
        return this.getDownloadUrl(_form);
      });
    }

    let apiUrl = `/project/${form.project}`;
    apiUrl += `/form/${form._id}`;
    apiUrl += `/submission/${this.submissionId}`;
    apiUrl += &apos;/download&apos;;

    let download = this.base + apiUrl;
    return new NativePromise((resolve, reject) =&gt; {
      this.getTempToken(3600, `GET:${apiUrl}`).then((tempToken) =&gt; {
        download += `?token=${tempToken.key}`;
        resolve(download);
      }, () =&gt; {
        resolve(download);
      }).catch(reject);
    });
  }

  uploadFile(storage, file, fileName, dir, progressCallback, url, options, fileKey, groupPermissions, groupId, uploadStartCallback, abortCallback) {
    const requestArgs = {
      provider: storage,
      method: &apos;upload&apos;,
      file: file,
      fileName: fileName,
      dir: dir
    };
    fileKey = fileKey || &apos;file&apos;;
    const request = Formio.pluginWait(&apos;preRequest&apos;, requestArgs)
      .then(() =&gt; {
        return Formio.pluginGet(&apos;fileRequest&apos;, requestArgs)
          .then((result) =&gt; {
            if (storage &amp;&amp; isNil(result)) {
              const Provider = Providers.getProvider(&apos;storage&apos;, storage);
              if (Provider) {
                const provider = new Provider(this);
                if (uploadStartCallback) {
                  uploadStartCallback();
                }
                return provider.uploadFile(file, fileName, dir, progressCallback, url, options, fileKey, groupPermissions, groupId, abortCallback);
              }
              else {
                throw (&apos;Storage provider not found&apos;);
              }
            }
            return result || { url: &apos;&apos; };
          });
      });

    return Formio.pluginAlter(&apos;wrapFileRequestPromise&apos;, request, requestArgs);
  }

  downloadFile(file, options) {
    const requestArgs = {
      method: &apos;download&apos;,
      file: file
    };

    const request = Formio.pluginWait(&apos;preRequest&apos;, requestArgs)
      .then(() =&gt; {
        return Formio.pluginGet(&apos;fileRequest&apos;, requestArgs)
          .then((result) =&gt; {
            if (file.storage &amp;&amp; isNil(result)) {
              const Provider = Providers.getProvider(&apos;storage&apos;, file.storage);
              if (Provider) {
                const provider = new Provider(this);
                return provider.downloadFile(file, options);
              }
              else {
                throw (&apos;Storage provider not found&apos;);
              }
            }
            return result || { url: &apos;&apos; };
          });
      });

    return Formio.pluginAlter(&apos;wrapFileRequestPromise&apos;, request, requestArgs);
  }

  deleteFile(file, options) {
    const requestArgs = {
      method: &apos;delete&apos;,
      file: file
    };

    const request = Formio.pluginWait(&apos;preRequest&apos;, requestArgs)
      .then(() =&gt; {
        return Formio.pluginGet(&apos;fileRequest&apos;, requestArgs)
          .then((result) =&gt; {
            if (file.storage &amp;&amp; isNil(result)) {
              const Provider = Providers.getProvider(&apos;storage&apos;, file.storage);
              if (Provider) {
                const provider = new Provider(this);
                return provider.deleteFile(file, options);
              }
              else {
                throw (&apos;Storage provider not found&apos;);
              }
            }
            return result || { url: &apos;&apos; };
          });
      });

    return Formio.pluginAlter(&apos;wrapFileRequestPromise&apos;, request, requestArgs);
  }

  /**
   * Returns the user permissions to a form and submission.
   *
   * @param user - The user or current user if undefined. For anonymous, use &quot;null&quot;
   * @param form - The form or current form if undefined. For no form check, use &quot;null&quot;
   * @param submission - The submisison or &quot;index&quot; if undefined.
   *
   * @return {create: boolean, read: boolean, edit: boolean, delete: boolean}
   */
  userPermissions(user, form, submission) {
    return NativePromise.all([
      (form !== undefined) ? NativePromise.resolve(form) : this.loadForm(),
      (user !== undefined) ? NativePromise.resolve(user) : this.currentUser(),
      (submission !== undefined || !this.submissionId) ? NativePromise.resolve(submission) : this.loadSubmission(),
      this.accessInfo()
    ]).then((results) =&gt; {
      const form = results.shift();
      const user = results.shift() || { _id: false, roles: [] };
      const submission = results.shift();
      const access = results.shift();
      const permMap = {
        create: &apos;create&apos;,
        read: &apos;read&apos;,
        update: &apos;edit&apos;,
        delete: &apos;delete&apos;
      };
      const perms = {
        user: user,
        form: form,
        access: access,
        create: false,
        read: false,
        edit: false,
        delete: false
      };
      for (const roleName in access.roles) {
        if (access.roles.hasOwnProperty(roleName)) {
          const role = access.roles[roleName];
          if (role.default &amp;&amp; (user._id === false)) {
            // User is anonymous. Add the anonymous role.
            user.roles.push(role._id);
          }
          else if (role.admin &amp;&amp; user.roles.indexOf(role._id) !== -1) {
            perms.create = true;
            perms.read = true;
            perms.delete = true;
            perms.edit = true;
            return perms;
          }
        }
      }
      if (form &amp;&amp; form.submissionAccess) {
        for (let i = 0; i &lt; form.submissionAccess.length; i++) {
          const permission = form.submissionAccess[i];
          const [perm, scope] = permission.type.split(&apos;_&apos;);
          if ([&apos;create&apos;, &apos;read&apos;, &apos;update&apos;, &apos;delete&apos;].includes(perm)) {
            if (_intersection(permission.roles, user.roles).length) {
              perms[permMap[perm]] = (scope === &apos;all&apos;) || (!submission || (user._id === submission.owner));
            }
          }
        }
      }
      // check for Group Permissions
      if (submission) {
        // we would anyway need to loop through components for create permission, so we&apos;ll do that for all of them
        eachComponent(form.components, (component, path) =&gt; {
          if (component &amp;&amp; component.defaultPermission) {
            const value = _get(submission.data, path);
            // make it work for single-select Group and multi-select Group
            const groups = Array.isArray(value) ? value : [value];
            groups.forEach(group =&gt; {
              if (
                group &amp;&amp; group._id &amp;&amp; // group id is present
                user.roles.indexOf(group._id) &gt; -1 // user has group id in his roles
              ) {
                if (component.defaultPermission === &apos;read&apos;) {
                  perms[permMap.read] = true;
                }
                if (component.defaultPermission === &apos;create&apos;) {
                  perms[permMap.create] = true;
                  perms[permMap.read] = true;
                }
                if (component.defaultPermission === &apos;write&apos;) {
                  perms[permMap.create] = true;
                  perms[permMap.read] = true;
                  perms[permMap.update] = true;
                }
                if (component.defaultPermission === &apos;admin&apos;) {
                  perms[permMap.create] = true;
                  perms[permMap.read] = true;
                  perms[permMap.update] = true;
                  perms[permMap.delete] = true;
                }
              }
            });
          }
        });
      }
      return perms;
    });
  }

  /**
   * Determine if the current user can submit a form.
   * @return {*}
   */
  canSubmit() {
    return this.userPermissions().then((perms) =&gt; {
      // If there is user and they cannot create, then check anonymous user permissions.
      if (!perms.create &amp;&amp; Formio.getUser()) {
        return this.userPermissions(null).then((anonPerms) =&gt; {
          if (anonPerms.create) {
            Formio.setUser(null);
            return true;
          }

          return false;
        });
      }

      return perms.create;
    });
  }

  getUrlParts(url) {
    return Formio.getUrlParts(url, this);
  }

  static getUrlParts(url, formio) {
    const base = (formio &amp;&amp; formio.base) ? formio.base : getFormio().baseUrl;
    let regex = &apos;^(http[s]?:\\/\\/)&apos;;
    if (base &amp;&amp; url.indexOf(base) === 0) {
      regex += `(${base.replace(/^http[s]?:\/\//, &apos;&apos;)})`;
    }
    else {
      regex += &apos;([^/]+)&apos;;
    }
    regex += &apos;($|\\/.*)&apos;;
    return url.match(new RegExp(regex));
  }

  static serialize(obj, _interpolate) {
    const str = [];
    const interpolate = (item) =&gt; {
      return _interpolate ? _interpolate(item) : item;
    };
    for (const p in obj) {
      if (obj.hasOwnProperty(p)) {
        str.push(`${encodeURIComponent(p)}=${encodeURIComponent(interpolate(obj[p]))}`);
      }
    }
    return str.join(&apos;&amp;&apos;);
  }

  static getRequestArgs(formio, type, url, method, data, opts) {
    method = (method || &apos;GET&apos;).toUpperCase();
    if (!opts || !isObject(opts)) {
      opts = {};
    }

    const requestArgs = {
      url,
      method,
      data: data || null,
      opts
    };

    if (type) {
      requestArgs.type = type;
    }

    if (formio) {
      requestArgs.formio = formio;
    }
    return requestArgs;
  }

  static makeStaticRequest(url, method, data, opts) {
    const requestArgs = getFormio().getRequestArgs(null, &apos;&apos;, url, method, data, opts);
    const request = getFormio().pluginWait(&apos;preRequest&apos;, requestArgs)
      .then(() =&gt; getFormio().pluginGet(&apos;staticRequest&apos;, requestArgs)
        .then((result) =&gt; {
          if (isNil(result)) {
            return getFormio().request(requestArgs.url, requestArgs.method, requestArgs.data, requestArgs.opts.header, requestArgs.opts);
          }
          return result;
        }));

    return getFormio().pluginAlter(&apos;wrapStaticRequestPromise&apos;, request, requestArgs);
  }

  static makeRequest(formio, type, url, method, data, opts) {
    if (!formio) {
      return getFormio().makeStaticRequest(url, method, data, opts);
    }

    const requestArgs = getFormio().getRequestArgs(formio, type, url, method, data, opts);
    requestArgs.opts = requestArgs.opts || {};
    requestArgs.opts.formio = formio;

    //for Formio requests default Accept and Content-type headers
    if (!requestArgs.opts.headers) {
      requestArgs.opts.headers = {};
    }
    requestArgs.opts.headers = _defaults(requestArgs.opts.headers, {
      &apos;Accept&apos;: &apos;application/json&apos;,
      &apos;Content-type&apos;: &apos;application/json&apos;
    });
    const request = getFormio().pluginWait(&apos;preRequest&apos;, requestArgs)
      .then(() =&gt; getFormio().pluginGet(&apos;request&apos;, requestArgs)
        .then((result) =&gt; {
          if (isNil(result)) {
            return getFormio().request(requestArgs.url, requestArgs.method, requestArgs.data, requestArgs.opts.header, requestArgs.opts);
          }
          return result;
        }));

    return getFormio().pluginAlter(&apos;wrapRequestPromise&apos;, request, requestArgs);
  }

  static request(url, method, data, header, opts) {
    if (!url) {
      return NativePromise.reject(&apos;No url provided&apos;);
    }
    const _Formio = getFormio();
    method = (method || &apos;GET&apos;).toUpperCase();

    // For reverse compatibility, if they provided the ignoreCache parameter,
    // then change it back to the options format where that is a parameter.
    if (isBoolean(opts)) {
      opts = { ignoreCache: opts };
    }
    if (!opts || !isObject(opts)) {
      opts = {};
    }

    // Generate a cachekey.
    const cacheKey = btoa(encodeURI(url));

    // Get the cached promise to save multiple loads.
    if (!opts.ignoreCache &amp;&amp; method === &apos;GET&apos; &amp;&amp; _Formio.cache.hasOwnProperty(cacheKey)) {
      return NativePromise.resolve(cloneResponse(_Formio.cache[cacheKey]));
    }

    // Set up and fetch request
    const headers = header || new Headers(opts.headers || {
      &apos;Accept&apos;: &apos;application/json&apos;,
      &apos;Content-type&apos;: &apos;application/json&apos;
    });
    const token = _Formio.getToken(opts);
    if (token &amp;&amp; !opts.noToken) {
      headers.append(&apos;x-jwt-token&apos;, token);
    }

    // The fetch-ponyfill can&apos;t handle a proper Headers class anymore. Change it back to an object.
    const headerObj = {};
    headers.forEach(function(value, name) {
      headerObj[name] = value;
    });

    let options = {
      method: method,
      headers: headerObj,
      mode: &apos;cors&apos;
    };
    if (data) {
      options.body = JSON.stringify(data);
    }

    // Allow plugins to alter the options.
    options = _Formio.pluginAlter(&apos;requestOptions&apos;, options, url);
    if (options.namespace || _Formio.namespace) {
      opts.namespace = options.namespace ||  _Formio.namespace;
    }

    const requestToken = options.headers[&apos;x-jwt-token&apos;];
    const result = _Formio.pluginAlter(&apos;wrapFetchRequestPromise&apos;, _Formio.fetch(url, options),
      { url, method, data, opts }).then((response) =&gt; {
      // Allow plugins to respond.
      response = _Formio.pluginAlter(&apos;requestResponse&apos;, response, _Formio, data);

      if (!response.ok) {
        if (response.status === 440) {
          _Formio.setToken(null, opts);
          _Formio.events.emit(&apos;formio.sessionExpired&apos;, response.body);
        }
        else if (response.status === 401) {
          _Formio.events.emit(&apos;formio.unauthorized&apos;, response.body);
        }
        else if (response.status === 416) {
          _Formio.events.emit(&apos;formio.rangeIsNotSatisfiable&apos;, response.body);
        }
        // Parse and return the error as a rejected promise to reject this promise
        return (response.headers.get(&apos;content-type&apos;).includes(&apos;application/json&apos;)
          ? response.json()
          : response.text())
          .then((error) =&gt; {
            return NativePromise.reject(error);
          });
      }

      // Handle fetch results
      const token = response.headers.get(&apos;x-jwt-token&apos;);

      // In some strange cases, the fetch library will return an x-jwt-token without sending
      // one to the server. This has even been debugged on the server to verify that no token
      // was introduced with the request, but the response contains a token. This is an Invalid
      // case where we do not send an x-jwt-token and get one in return for any GET request.
      let tokenIntroduced = false;
      if (
        (method === &apos;GET&apos;) &amp;&amp;
        !requestToken &amp;&amp;
        token &amp;&amp;
        !opts.external &amp;&amp;
        !url.includes(&apos;token=&apos;) &amp;&amp;
        !url.includes(&apos;x-jwt-token=&apos;)
      ) {
        console.warn(&apos;Token was introduced in request.&apos;);
        tokenIntroduced = true;
      }

      if (
        response.status &gt;= 200 &amp;&amp;
        response.status &lt; 300 &amp;&amp;
        token &amp;&amp;
        token !== &apos;&apos; &amp;&amp;
        !tokenIntroduced
      ) {
        _Formio.setToken(token, opts);
      }
      // 204 is no content. Don&apos;t try to .json() it.
      if (response.status === 204) {
        return {};
      }

      const getResult = response.headers.get(&apos;content-type&apos;).includes(&apos;application/json&apos;)
        ? response.json()
        : response.text();
      return getResult.then((result) =&gt; {
        // Add some content-range metadata to the result here
        let range = response.headers.get(&apos;content-range&apos;);
        if (range &amp;&amp; isObject(result)) {
          range = range.split(&apos;/&apos;);
          if (range[0] !== &apos;*&apos;) {
            const skipLimit = range[0].split(&apos;-&apos;);
            result.skip = Number(skipLimit[0]);
            result.limit = skipLimit[1] - skipLimit[0] + 1;
          }
          result.serverCount = range[1] === &apos;*&apos; ? range[1] : Number(range[1]);
        }

        if (!opts.getHeaders) {
          return result;
        }

        const headers = {};
        response.headers.forEach((item, key) =&gt; {
          headers[key] = item;
        });

        // Return the result with the headers.
        return {
          result,
          headers,
        };
      });
    })
    .then((result) =&gt; {
      if (opts.getHeaders) {
        return result;
      }

      // Cache the response.
      if (method === &apos;GET&apos;) {
        _Formio.cache[cacheKey] = result;
      }

      return cloneResponse(result);
    })
    .catch((err) =&gt; {
      if (err === &apos;Bad Token&apos;) {
        _Formio.setToken(null, opts);
        _Formio.events.emit(&apos;formio.badToken&apos;, err);
      }
      if (err.message) {
        err.message = `Could not connect to API server (${err.message})`;
        err.networkError = true;
      }

      if (method === &apos;GET&apos;) {
        delete _Formio.cache[cacheKey];
      }

      return NativePromise.reject(err);
    });

    return result;
  }

  // Needed to maintain reverse compatability...
  static get token() {
    if (!getFormio().tokens) {
      getFormio().tokens = {};
    }

    return getFormio().tokens.formioToken || &apos;&apos;;
  }

  // Needed to maintain reverse compatability...
  static set token(token) {
    if (!getFormio().tokens) {
      getFormio().tokens = {};
    }

    getFormio().tokens.formioToken = token || &apos;&apos;;
  }

  static setToken(token = &apos;&apos;, opts) {
    token = token || &apos;&apos;;
    opts = (typeof opts === &apos;string&apos;) ? { namespace: opts } : opts || {};
    const tokenName = `${opts.namespace || getFormio().namespace || &apos;formio&apos;}Token`;

    if (!getFormio().tokens) {
      getFormio().tokens = {};
    }

    if (!token) {
      if (!opts.fromUser) {
        opts.fromToken = true;
        getFormio().setUser(null, opts);
      }
      // iOS in private browse mode will throw an error but we can&apos;t detect ahead of time that we are in private mode.
      try {
        localStorage.removeItem(tokenName);
      }
      catch (err) {
        cookies.erase(tokenName, { path: &apos;/&apos; });
      }
      getFormio().tokens[tokenName] = token;
      return NativePromise.resolve(null);
    }

    if (getFormio().tokens[tokenName] !== token) {
      getFormio().tokens[tokenName] = token;
      // iOS in private browse mode will throw an error but we can&apos;t detect ahead of time that we are in private mode.
      try {
        localStorage.setItem(tokenName, token);
      }
      catch (err) {
        cookies.set(tokenName, token, { path: &apos;/&apos; });
      }
    }
    // Return or updates the current user
    return getFormio().currentUser(opts.formio, opts);
  }

  static getToken(options) {
    options = (typeof options === &apos;string&apos;) ? { namespace: options } : options || {};
    const tokenName = `${options.namespace || getFormio().namespace || &apos;formio&apos;}Token`;
    const decodedTokenName = options.decode ? `${tokenName}Decoded` : tokenName;
    if (!getFormio().tokens) {
      getFormio().tokens = {};
    }

    if (getFormio().tokens[decodedTokenName]) {
      return getFormio().tokens[decodedTokenName];
    }
    try {
      getFormio().tokens[tokenName] = localStorage.getItem(tokenName) || &apos;&apos;;
      if (options.decode) {
        getFormio().tokens[decodedTokenName] = getFormio().tokens[tokenName] ? jwtDecode(getFormio().tokens[tokenName]) : {};
        return getFormio().tokens[decodedTokenName];
      }
      return getFormio().tokens[tokenName];
    }
    catch (e) {
      getFormio().tokens[tokenName] = cookies.get(tokenName);
      return getFormio().tokens[tokenName];
    }
  }

  static setUser(user, opts = {}) {
    var userName = `${opts.namespace || getFormio().namespace || &apos;formio&apos;}User`;
    if (!user) {
      if (!opts.fromToken) {
        opts.fromUser = true;
        getFormio().setToken(null, opts);
      }

      // Emit an event on the cleared user.
      getFormio().events.emit(&apos;formio.user&apos;, null);

      // iOS in private browse mode will throw an error but we can&apos;t detect ahead of time that we are in private mode.
      try {
        return localStorage.removeItem(userName);
      }
      catch (err) {
        return cookies.erase(userName, { path: &apos;/&apos; });
      }
    }
    // iOS in private browse mode will throw an error but we can&apos;t detect ahead of time that we are in private mode.
    try {
      localStorage.setItem(userName, JSON.stringify(user));
    }
    catch (err) {
      cookies.set(userName, JSON.stringify(user), { path: &apos;/&apos; });
    }

    // Emit an event on the authenticated user.
    getFormio().events.emit(&apos;formio.user&apos;, user);
  }

  static getUser(options) {
    options = options || {};
    var userName = `${options.namespace || getFormio().namespace || &apos;formio&apos;}User`;
    try {
      return JSON.parse(localStorage.getItem(userName) || null);
    }
    catch (e) {
      return JSON.parse(cookies.get(userName));
    }
  }

  static setBaseUrl(url) {
    getFormio().baseUrl = url;
    if (!getFormio().projectUrlSet) {
      getFormio().projectUrl = url;
    }
  }

  static getBaseUrl() {
    return getFormio().baseUrl;
  }

  static setApiUrl(url) {
    return getFormio().setBaseUrl(url);
  }

  static getApiUrl() {
    return getFormio().getBaseUrl();
  }

  static setAppUrl(url) {
    console.warn(&apos;Formio.setAppUrl() is deprecated. Use Formio.setProjectUrl instead.&apos;);
    getFormio().projectUrl = url;
    getFormio().projectUrlSet = true;
  }

  static setProjectUrl(url) {
    getFormio().projectUrl = url;
    getFormio().projectUrlSet = true;
  }

  static setAuthUrl(url) {
    getFormio().authUrl = url;
  }

  static getAppUrl() {
    console.warn(&apos;Formio.getAppUrl() is deprecated. Use Formio.getProjectUrl instead.&apos;);
    return getFormio().projectUrl;
  }

  static getProjectUrl() {
    return getFormio().projectUrl;
  }

  static clearCache() {
    getFormio().cache = {};
  }

  static noop() {}
  static identity(value) {
    return value;
  }

  static deregisterPlugin(plugin) {
    const beforeLength = getFormio().plugins.length;
    getFormio().plugins = getFormio().plugins.filter((p) =&gt; {
      if (p !== plugin &amp;&amp; p.__name !== plugin) {
        return true;
      }

      (p.deregister || getFormio().noop).call(plugin, getFormio());
      return false;
    });
    return beforeLength !== getFormio().plugins.length;
  }

  static registerPlugin(plugin, name) {
    const __Formio = getFormio();
    __Formio.plugins.push(plugin);
    __Formio.plugins.sort((a, b) =&gt; (b.priority || 0) - (a.priority || 0));
    plugin.__name = name;
    (plugin.init || __Formio.noop).call(plugin, __Formio);
  }

  static getPlugin(name) {
    for (const plugin of getFormio().plugins) {
      if (plugin.__name === name) {
        return plugin;
      }
    }

    return null;
  }

  static pluginWait(pluginFn, ...args) {
    return NativePromise.all(getFormio().plugins.map((plugin) =&gt;
      (plugin[pluginFn] || getFormio().noop).call(plugin, ...args)));
  }

  static pluginGet(pluginFn, ...args) {
    const callPlugin = (index) =&gt; {
      const plugin = getFormio().plugins[index];

      if (!plugin) {
        return NativePromise.resolve(null);
      }

      return NativePromise.resolve((plugin[pluginFn] || getFormio().noop).call(plugin, ...args))
        .then((result) =&gt; {
          if (!isNil(result)) {
            return result;
          }

          return callPlugin(index + 1);
        });
    };
    return callPlugin(0);
  }

  static pluginAlter(pluginFn, value, ...args) {
    return getFormio().plugins.reduce((value, plugin) =&gt;
      (plugin[pluginFn] || getFormio().identity)(value, ...args), value);
  }

  static accessInfo(formio) {
    const projectUrl = formio ? formio.projectUrl : getFormio().projectUrl;
    return getFormio().makeRequest(formio, &apos;accessInfo&apos;, `${projectUrl}/access`);
  }

  static projectRoles(formio) {
    const projectUrl = formio ? formio.projectUrl : getFormio().projectUrl;
    return getFormio().makeRequest(formio, &apos;projectRoles&apos;, `${projectUrl}/role`);
  }

  static currentUser(formio, options) {
    let authUrl = getFormio().authUrl;
    if (!authUrl) {
      authUrl = formio ? formio.projectUrl : (getFormio().projectUrl || getFormio().baseUrl);
    }
    authUrl += &apos;/current&apos;;
    const user = getFormio().getUser(options);
    if (user) {
      return getFormio().pluginAlter(&apos;wrapStaticRequestPromise&apos;, NativePromise.resolve(user), {
        url: authUrl,
        method: &apos;GET&apos;,
        options
      });
    }

    const token = getFormio().getToken(options);
    if ((!options || !options.external) &amp;&amp; !token) {
      return getFormio().pluginAlter(&apos;wrapStaticRequestPromise&apos;, NativePromise.resolve(null), {
        url: authUrl,
        method: &apos;GET&apos;,
        options
      });
    }
    return getFormio().makeRequest(formio, &apos;currentUser&apos;, authUrl, &apos;GET&apos;, null, options)
      .then((response) =&gt; {
        getFormio().setUser(response, options);
        return response;
      });
  }

  static logout(formio, options) {
    options = options || {};
    options.formio = formio;
    const projectUrl = getFormio().authUrl ? getFormio().authUrl : (formio ? formio.projectUrl : getFormio().baseUrl);
    return getFormio().makeRequest(formio, &apos;logout&apos;, `${projectUrl}/logout`)
      .then(function(result) {
        getFormio().setToken(null, options);
        getFormio().setUser(null, options);
        getFormio().clearCache();
        return result;
      })
      .catch(function(err) {
        getFormio().setToken(null, options);
        getFormio().setUser(null, options);
        getFormio().clearCache();
        throw err;
      });
  }

  static pageQuery() {
    const pageQuery = {};
    pageQuery.paths = [];
    const hashes = location.hash.substr(1).replace(/\?/g, &apos;&amp;&apos;).split(&apos;&amp;&apos;);
    let parts = [];
    location.search.substr(1).split(&apos;&amp;&apos;).forEach(function(item) {
      parts = item.split(&apos;=&apos;);
      if (parts.length &gt; 1) {
        pageQuery[parts[0]] = parts[1] &amp;&amp; decodeURIComponent(parts[1]);
      }
    });

    hashes.forEach(function(item) {
      parts = item.split(&apos;=&apos;);
      if (parts.length &gt; 1) {
        pageQuery[parts[0]] = parts[1] &amp;&amp; decodeURIComponent(parts[1]);
      }
      else if (item.indexOf(&apos;/&apos;) === 0) {
        pageQuery.paths = item.substr(1).split(&apos;/&apos;);
      }
    });
    return pageQuery;
  }

  static oAuthCurrentUser(formio, token) {
    return getFormio().currentUser(formio, {
      external: true,
      headers: {
        Authorization: `Bearer ${token}`
      }
    });
  }

  static samlInit(options) {
    options = options || {};
    const query = getFormio().pageQuery();
    if (query.saml) {
      getFormio().setUser(null);
      const retVal = getFormio().setToken(query.saml);
      let uri = window.location.toString();
      uri = uri.substring(0, uri.indexOf(&apos;?&apos;));
      if (window.location.hash) {
        uri += window.location.hash;
      }
      window.history.replaceState({}, document.title, uri);
      return retVal;
    }

    // Set the relay if not provided.
    if (!options.relay) {
      options.relay = window.location.href;
    }

    // go to the saml sso endpoint for this project.
    const authUrl = getFormio().authUrl || getFormio().projectUrl;
    window.location.href = `${authUrl}/saml/sso?relay=${encodeURI(options.relay)}`;
    return false;
  }

  static oktaInit(options) {
    options = options || {};
    if (typeof OktaAuth !== undefined) {
      options.OktaAuth = OktaAuth;
    }

    if (typeof options.OktaAuth === undefined) {
      const errorMessage = &apos;Cannot find OktaAuth. Please include the Okta JavaScript SDK within your application. See https://developer.okta.com/code/javascript/okta_auth_sdk for an example.&apos;;
      console.warn(errorMessage);
      return NativePromise.reject(errorMessage);
    }
    return new NativePromise((resolve, reject) =&gt; {
      const Okta = options.OktaAuth;
      delete options.OktaAuth;
      var authClient = new Okta(options);
      authClient.tokenManager.get(&apos;accessToken&apos;)
        .then(accessToken =&gt; {
          if (accessToken) {
            resolve(getFormio().oAuthCurrentUser(options.formio, accessToken.accessToken));
          }
          else if (location.hash) {
            authClient.token.parseFromUrl()
              .then(token =&gt; {
                authClient.tokenManager.add(&apos;accessToken&apos;, token);
                resolve(getFormio().oAuthCurrentUser(options.formio, token.accessToken));
              })
              .catch(err =&gt; {
                console.warn(err);
                reject(err);
              });
          }
          else {
            authClient.token.getWithRedirect({
              responseType: &apos;token&apos;,
              scopes: options.scopes
            });
            resolve(false);
          }
        })
        .catch(error =&gt; {
          reject(error);
        });
    });
  }

  static ssoInit(type, options) {
    switch (type) {
      case &apos;saml&apos;:
        return getFormio().samlInit(options);
      case &apos;okta&apos;:
        return getFormio().oktaInit(options);
      default:
        console.warn(&apos;Unknown SSO type&apos;);
        return NativePromise.reject(&apos;Unknown SSO type&apos;);
    }
  }

  static requireLibrary(name, property, src, polling) {
    if (!getFormio().libraries.hasOwnProperty(name)) {
      getFormio().libraries[name] = {};
      getFormio().libraries[name].ready = new NativePromise((resolve, reject) =&gt; {
        getFormio().libraries[name].resolve = resolve;
        getFormio().libraries[name].reject = reject;
      });

      const callbackName = `${name}Callback`;

      if (!polling &amp;&amp; !window[callbackName]) {
        window[callbackName] = () =&gt; getFormio().libraries[name].resolve();
      }

      // See if the plugin already exists.
      const plugin = _get(window, property);
      if (plugin) {
        getFormio().libraries[name].resolve(plugin);
      }
      else {
        src = Array.isArray(src) ? src : [src];
        src.forEach((lib) =&gt; {
          let attrs = {};
          let elementType = &apos;&apos;;
          if (typeof lib === &apos;string&apos;) {
            lib = {
              type: &apos;script&apos;,
              src: lib,
            };
          }
          switch (lib.type) {
            case &apos;script&apos;:
              elementType = &apos;script&apos;;
              attrs = {
                src: lib.src,
                type: &apos;text/javascript&apos;,
                defer: true,
                async: true,
                referrerpolicy: &apos;origin&apos;,
              };
              break;
            case &apos;styles&apos;:
              elementType = &apos;link&apos;;
              attrs = {
                href: lib.src,
                rel: &apos;stylesheet&apos;,
              };
              break;
          }

          // Add the script to the top of the page.
          const element = document.createElement(elementType);
          if (element.setAttribute) {
            for (const attr in attrs) {
              element.setAttribute(attr, attrs[attr]);
            }
          }

          const { head } = document;
          if (head) {
            head.appendChild(element);
          }
        });

        // if no callback is provided, then check periodically for the script.
        if (polling) {
          const interval = setInterval(() =&gt; {
            const plugin = _get(window, property);
            if (plugin) {
              clearInterval(interval);
              getFormio().libraries[name].resolve(plugin);
            }
          }, 200);
        }
      }
    }
    return getFormio().libraries[name].ready;
  }

  static libraryReady(name) {
    if (
      getFormio().libraries.hasOwnProperty(name) &amp;&amp;
      getFormio().libraries[name].ready
    ) {
      return getFormio().libraries[name].ready;
    }

    return NativePromise.reject(`${name} library was not required.`);
  }

  static addToGlobal(global) {
    if (typeof global === &apos;object&apos; &amp;&amp; !global.Formio) {
      global.Formio = Formio;
    }
  }

  static setPathType(type) {
    if (typeof type === &apos;string&apos;) {
      getFormio().pathType = type;
    }
  }

  static getPathType() {
    return getFormio().pathType;
  }
}

// Define all the static properties.
Formio.libraries = {};
Formio.Promise = NativePromise;
Formio.fetch = fetch;
Formio.Headers = Headers;
Formio.baseUrl = &apos;https://api.form.io&apos;;
Formio.projectUrl = Formio.baseUrl;
Formio.authUrl = &apos;&apos;;
Formio.projectUrlSet = false;
Formio.plugins = [];
Formio.cache = {};
Formio.Providers = Providers;
Formio.version = &apos;---VERSION---&apos;;
Formio.pathType = &apos;&apos;;
Formio.events = new EventEmitter();

if (typeof global !== &apos;undefined&apos;) {
  Formio.addToGlobal(global);
}
if (typeof window !== &apos;undefined&apos;) {
  Formio.addToGlobal(window);
}

// It makes sure that we use global Formio.
function getFormio() {
  if (typeof window === &apos;object&apos; &amp;&amp; typeof window.Formio !== &apos;undefined&apos;) {
    return window.Formio;
  }

  if (typeof global === &apos;object&apos; &amp;&amp; typeof global.Formio !== &apos;undefined&apos;) {
    return global.Formio;
  }

  return Formio;
}

export default getFormio();
</code></pre>

</div>

<footer class="footer">
  Generated by <a href="https://esdoc.org">ESDoc<span data-ice="esdocVersion">(1.1.0)</span><img src="./image/esdoc-logo-mini-black.png"></a>
</footer>

<script src="script/search_index.js"></script>
<script src="script/search.js"></script>
<script src="script/pretty-print.js"></script>
<script src="script/inherited-summary.js"></script>
<script src="script/test-summary.js"></script>
<script src="script/inner-link.js"></script>
<script src="script/patch-for-local.js"></script>
</body>
</html>
